class
	TEST_TWIN

inherit
	ES_TEST

create
	make

feature {NONE} -- Initialization

	make
			-- Run application.
		do
			add_boolean_case (agent test_twin)

			show_browser
			run_espec
		end

feature
	test_twin: BOOLEAN
		local
			a1, a2, a3: A
			arr1, arr2, arr3: ARRAY[STRING]
		do
			create a1.make
			a2 := a1.twin
			Result := a1 /= a2 and a1.b = a2.b and a1.arr = a2.arr
			check Result end

			a2 := a1.deep_twin
			Result := a1 /= a2 and a1.b /= a2.b and a1.arr /= a2.arr
			check Result end

			create arr1.make_empty
			arr1.force ("A", 1)
			arr2 := arr1.twin
			Result := arr1 /= arr2 and arr1[1] = arr2[1]
			check Result end


			arr3 := arr1.deep_twin
			Result := arr1 /= arr3 and arr1[1] /= arr3[1]
			check Result end
		end

end
